From 385ca0fecc1110a299c05efd3cb4fc9dfc6dfe17 Mon Sep 17 00:00:00 2001
From: Alex Matchneer <machty@gmail.com>
Date: Tue, 4 Mar 2025 03:37:47 -0500
Subject: [PATCH 07/13] docs: clean up and document
 `createLanguageServicePlugin` and `createAsyncLanguageServicePlugin` (#261)

---
 packages/language-core/lib/types.ts           |  31 ++-
 .../lib/node/proxyLanguageService.ts          |  12 +
 packages/typescript/lib/node/transform.ts     |   6 +
 .../createAsyncLanguageServicePlugin.ts       | 217 ++++++++----------
 .../quickstart/createLanguageServicePlugin.ts | 110 ++-------
 .../quickstart/languageServicePluginCommon.ts | 116 ++++++++++
 6 files changed, 274 insertions(+), 218 deletions(-)
 create mode 100644 packages/typescript/lib/quickstart/languageServicePluginCommon.ts

diff --git a/packages/typescript/lib/node/proxyLanguageService.ts b/packages/typescript/lib/node/proxyLanguageService.ts
index b6cc56da..ad767414 100644
--- a/packages/typescript/lib/node/proxyLanguageService.ts
+++ b/packages/typescript/lib/node/proxyLanguageService.ts
@@ -38,6 +38,18 @@ import { getServiceScript } from './utils';
 
 const windowsPathReg = /\\/g;
 
+/**
+ * Creates and returns a Proxy around the base TypeScript LanguageService.
+ *
+ * This is used by the Volar TypeScript Plugin (which can be created by `createLanguageServicePlugin`
+ * and `createAsyncLanguageServicePlugin`) as an adapter layer between the TypeScript Language Service
+ * plugin API (see https://github.com/microsoft/TypeScript/wiki/Writing-a-Language-Service-Plugin)
+ * and a Volar `Language`.
+ *
+ * Once the `initialize` method is called, the proxy will begin intercepting requests and
+ * enhancing the default behavior of the LanguageService with enhancements based on
+ * the Volar `Language` that has been passed to `initialize`.
+ */
 export function createProxyLanguageService(languageService: ts.LanguageService) {
 	const proxyCache = new Map<string | symbol, Function | undefined>();
 	let getProxyMethod: ((target: ts.LanguageService, p: string | symbol) => Function | undefined) | undefined;
diff --git a/packages/typescript/lib/node/transform.ts b/packages/typescript/lib/node/transform.ts
index 6cfda2b4..32d266e3 100644
--- a/packages/typescript/lib/node/transform.ts
+++ b/packages/typescript/lib/node/transform.ts
@@ -8,6 +8,12 @@ import { getServiceScript } from './utils';
 const transformedDiagnostics = new WeakMap<ts.Diagnostic, ts.Diagnostic | undefined>();
 const transformedSourceFile = new WeakSet<ts.SourceFile>();
 
+/**
+ * This file contains a number of facilities for transforming `ts.Diagnostic`s returned
+ * from the  base TypeScript LanguageService, which reference locations in generated
+ * TS code (e.g. the TypeScript codegen'd from the script portion of a .vue file) into locations
+ * in the script portion of the .vue file.
+ */
 export function transformCallHierarchyItem(
 	language: Language<string>,
 	item: ts.CallHierarchyItem,
diff --git a/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts b/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
index 90b40998..a27d7d62 100644
--- a/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
+++ b/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
@@ -1,154 +1,121 @@
-import { FileMap, Language, LanguagePlugin, createLanguage } from '@volar/language-core';
 import type * as ts from 'typescript';
-import { resolveFileLanguageId } from '../common';
 import { createProxyLanguageService } from '../node/proxyLanguageService';
-import { decorateLanguageServiceHost, searchExternalFiles } from '../node/decorateLanguageServiceHost';
-import { arrayItemsEqual, decoratedLanguageServiceHosts, decoratedLanguageServices, externalFiles } from './createLanguageServicePlugin';
+import { createLanguageCommon, isHasAlreadyDecoratedLanguageService, makeGetExternalFiles, makeGetScriptInfoWithLargeFileFailsafe } from './languageServicePluginCommon';
+import type { createPluginCallbackAsync } from './languageServicePluginCommon';
 
+/**
+ * Creates and returns a TS Service Plugin that supports async initialization.
+ * Essentially, this functions the same as `createLanguageServicePlugin`, but supports
+ * use cases in which the plugin callback must be async. For example in mdx-analyzer
+ * and Glint, this async variant is required because Glint + mdx-analyzer are written
+ * in ESM and get transpiled to CJS, which requires usage of `await import()` to load
+ * the necessary dependencies and fully initialize the plugin.
+ *
+ * To handle the period of time in which the plugin is initializing, this async
+ * variant stubs a number of methods on the LanguageServiceHost to handle the uninitialized state.
+ *
+ * Additionally, this async variant requires a few extra args pertaining to
+ * file extensions intended to be handled by the TS Plugin. In the synchronous variant,
+ * these can be synchronously inferred from elsewhere but for the async variant, they
+ * need to be passed in.
+ *
+ * See https://github.com/microsoft/TypeScript/wiki/Writing-a-Language-Service-Plugin for
+ * more information.
+ */
 export function createAsyncLanguageServicePlugin(
 	extensions: string[],
 	getScriptKindForExtraExtensions: ts.ScriptKind | ((fileName: string) => ts.ScriptKind),
-	create: (
-		ts: typeof import('typescript'),
-		info: ts.server.PluginCreateInfo
-	) => Promise<{
-		languagePlugins: LanguagePlugin<string>[],
-		setup?: (language: Language<string>) => void;
-	}>
+	createPluginCallbackAsync: createPluginCallbackAsync
 ): ts.server.PluginModuleFactory {
 	return modules => {
 		const { typescript: ts } = modules;
+
 		const pluginModule: ts.server.PluginModule = {
 			create(info) {
-				if (
-					!decoratedLanguageServices.has(info.languageService)
-					&& !decoratedLanguageServiceHosts.has(info.languageServiceHost)
-				) {
-					decoratedLanguageServices.add(info.languageService);
-					decoratedLanguageServiceHosts.add(info.languageServiceHost);
-
-					const emptySnapshot = ts.ScriptSnapshot.fromString('');
-					const getScriptSnapshot = info.languageServiceHost.getScriptSnapshot.bind(info.languageServiceHost);
-					const getScriptVersion = info.languageServiceHost.getScriptVersion.bind(info.languageServiceHost);
-					const getScriptKind = info.languageServiceHost.getScriptKind?.bind(info.languageServiceHost);
-					const getProjectVersion = info.languageServiceHost.getProjectVersion?.bind(info.languageServiceHost);
-
-					let initialized = false;
-
-					info.languageServiceHost.getScriptSnapshot = fileName => {
-						if (!initialized) {
-							if (extensions.some(ext => fileName.endsWith(ext))) {
-								return emptySnapshot;
-							}
-							if (getScriptInfo(fileName)?.isScriptOpen()) {
-								return emptySnapshot;
-							}
-						}
-						return getScriptSnapshot(fileName);
-					};
-					info.languageServiceHost.getScriptVersion = fileName => {
-						if (!initialized) {
-							if (extensions.some(ext => fileName.endsWith(ext))) {
-								return 'initializing...';
-							}
-							if (getScriptInfo(fileName)?.isScriptOpen()) {
-								return getScriptVersion(fileName) + ',initializing...';
-							}
-						}
-						return getScriptVersion(fileName);
-					};
-					if (getScriptKind) {
-						info.languageServiceHost.getScriptKind = fileName => {
-							if (!initialized && extensions.some(ext => fileName.endsWith(ext))) {
-								// bypass upstream bug https://github.com/microsoft/TypeScript/issues/57631
-								// TODO: check if the bug is fixed in 5.5
-								if (typeof getScriptKindForExtraExtensions === 'function') {
-									return getScriptKindForExtraExtensions(fileName);
-								}
-								else {
-									return getScriptKindForExtraExtensions;
-								}
-							}
-							return getScriptKind(fileName);
-						};
-					}
-					if (getProjectVersion) {
-						info.languageServiceHost.getProjectVersion = () => {
-							if (!initialized) {
-								return getProjectVersion() + ',initializing...';
-							}
-							return getProjectVersion();
-						};
-					}
+				if (!isHasAlreadyDecoratedLanguageService(info)) {
+					const state = decorateWithAsyncInitializationHandling(ts, info, extensions, getScriptKindForExtraExtensions);
 
 					const { proxy, initialize } = createProxyLanguageService(info.languageService);
 					info.languageService = proxy;
 
-					create(ts, info).then(({ languagePlugins, setup }) => {
-						const language = createLanguage<string>(
-							[
-								...languagePlugins,
-								{ getLanguageId: resolveFileLanguageId },
-							],
-							new FileMap(ts.sys.useCaseSensitiveFileNames),
-							(fileName, _, shouldRegister) => {
-								let snapshot: ts.IScriptSnapshot | undefined;
-								if (shouldRegister) {
-									// We need to trigger registration of the script file with the project, see #250
-									snapshot = getScriptSnapshot(fileName);
-								}
-								else {
-									snapshot = getScriptInfo(fileName)?.getSnapshot();
-									if (!snapshot) {
-										// trigger projectService.getOrCreateScriptInfoNotOpenedByClient
-										info.project.getScriptVersion(fileName);
-										snapshot = getScriptInfo(fileName)?.getSnapshot();
-									}
-								}
-								if (snapshot) {
-									language.scripts.set(fileName, snapshot);
-								}
-								else {
-									language.scripts.delete(fileName);
-								}
-							}
-						);
+					createPluginCallbackAsync(ts, info).then((createPluginResult) => {
+						createLanguageCommon(createPluginResult, ts, info, initialize);
 
-						initialize(language);
-						decorateLanguageServiceHost(ts, language, info.languageServiceHost);
-						setup?.(language);
+						state.initialized = true;
 
-						initialized = true;
 						if ('markAsDirty' in info.project && typeof info.project.markAsDirty === 'function') {
+							// This is an attempt to mark the project as dirty so that in case the IDE/tsserver
+							// already finished a first pass of generating diagnostics (or other things), another
+							// pass will be triggered which should hopefully make use of this now-initialized plugin.
 							info.project.markAsDirty();
 						}
 					});
 				}
 
 				return info.languageService;
-
-				function getScriptInfo(fileName: string) {
-					// getSnapshot could be crashed if the file is too large
-					try {
-						return info.project.getScriptInfo(fileName);
-					} catch { }
-				}
-			},
-			getExternalFiles(project, updateLevel = 0) {
-				if (
-					updateLevel >= (1 satisfies ts.ProgramUpdateLevel.RootNamesAndUpdate)
-					|| !externalFiles.has(project)
-				) {
-					const oldFiles = externalFiles.get(project);
-					const newFiles = extensions.length ? searchExternalFiles(ts, project, extensions) : [];
-					externalFiles.set(project, newFiles);
-					if (oldFiles && !arrayItemsEqual(oldFiles, newFiles)) {
-						project.refreshDiagnostics();
-					}
-				}
-				return externalFiles.get(project)!;
 			},
+			getExternalFiles: makeGetExternalFiles(ts),
 		};
 		return pluginModule;
 	};
 }
+
+function decorateWithAsyncInitializationHandling(ts: typeof import('typescript'), info: ts.server.PluginCreateInfo, extensions: string[], getScriptKindForExtraExtensions: ts.ScriptKind | ((fileName: string) => ts.ScriptKind)) {
+	const emptySnapshot = ts.ScriptSnapshot.fromString('');
+	const getScriptSnapshot = info.languageServiceHost.getScriptSnapshot.bind(info.languageServiceHost);
+	const getScriptVersion = info.languageServiceHost.getScriptVersion.bind(info.languageServiceHost);
+	const getScriptKind = info.languageServiceHost.getScriptKind?.bind(info.languageServiceHost);
+	const getProjectVersion = info.languageServiceHost.getProjectVersion?.bind(info.languageServiceHost);
+
+	const getScriptInfo = makeGetScriptInfoWithLargeFileFailsafe(info);
+
+	const state = { initialized: false };
+
+	info.languageServiceHost.getScriptSnapshot = fileName => {
+		if (!state.initialized) {
+			if (extensions.some(ext => fileName.endsWith(ext))) {
+				return emptySnapshot;
+			}
+			if (getScriptInfo(fileName)?.isScriptOpen()) {
+				return emptySnapshot;
+			}
+		}
+		return getScriptSnapshot(fileName);
+	};
+	info.languageServiceHost.getScriptVersion = fileName => {
+		if (!state.initialized) {
+			if (extensions.some(ext => fileName.endsWith(ext))) {
+				return 'initializing...';
+			}
+			if (getScriptInfo(fileName)?.isScriptOpen()) {
+				return getScriptVersion(fileName) + ',initializing...';
+			}
+		}
+		return getScriptVersion(fileName);
+	};
+	if (getScriptKind) {
+		info.languageServiceHost.getScriptKind = fileName => {
+			if (!state.initialized && extensions.some(ext => fileName.endsWith(ext))) {
+				// bypass upstream bug https://github.com/microsoft/TypeScript/issues/57631
+				// TODO: check if the bug is fixed in 5.5
+				if (typeof getScriptKindForExtraExtensions === 'function') {
+					return getScriptKindForExtraExtensions(fileName);
+				}
+				else {
+					return getScriptKindForExtraExtensions;
+				}
+			}
+			return getScriptKind(fileName);
+		};
+	}
+	if (getProjectVersion) {
+		info.languageServiceHost.getProjectVersion = () => {
+			if (!state.initialized) {
+				return getProjectVersion() + ',initializing...';
+			}
+			return getProjectVersion();
+		};
+	}
+
+	return state;
+}
diff --git a/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts b/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts
index bf86043b..edec2548 100644
--- a/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts
+++ b/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts
@@ -1,114 +1,42 @@
-import { FileMap, Language, LanguagePlugin, createLanguage } from '@volar/language-core';
 import type * as ts from 'typescript';
-import { resolveFileLanguageId } from '../common';
 import { createProxyLanguageService } from '../node/proxyLanguageService';
-import { decorateLanguageServiceHost, searchExternalFiles } from '../node/decorateLanguageServiceHost';
-
-export const externalFiles = new WeakMap<ts.server.Project, string[]>();
-export const projectExternalFileExtensions = new WeakMap<ts.server.Project, string[]>();
-export const decoratedLanguageServices = new WeakSet<ts.LanguageService>();
-export const decoratedLanguageServiceHosts = new WeakSet<ts.LanguageServiceHost>();
+import { createLanguageCommon, isHasAlreadyDecoratedLanguageService, makeGetExternalFiles, projectExternalFileExtensions } from './languageServicePluginCommon';
+import type { createPluginCallbackSync } from './languageServicePluginCommon';
 
+/**
+ * Creates and returns a TS Service Plugin using Volar primitives.
+ *
+ * See https://github.com/microsoft/TypeScript/wiki/Writing-a-Language-Service-Plugin for
+ * more information.
+ */
 export function createLanguageServicePlugin(
-	create: (
-		ts: typeof import('typescript'),
-		info: ts.server.PluginCreateInfo
-	) => {
-		languagePlugins: LanguagePlugin<string>[],
-		setup?: (language: Language<string>) => void;
-	}
+	createPluginCallback: createPluginCallbackSync
 ): ts.server.PluginModuleFactory {
 	return modules => {
 		const { typescript: ts } = modules;
+
 		const pluginModule: ts.server.PluginModule = {
 			create(info) {
-				if (
-					!decoratedLanguageServices.has(info.languageService)
-					&& !decoratedLanguageServiceHosts.has(info.languageServiceHost)
-				) {
-					decoratedLanguageServices.add(info.languageService);
-					decoratedLanguageServiceHosts.add(info.languageServiceHost);
-
-					const { languagePlugins, setup } = create(ts, info);
-					const extensions = languagePlugins
+				if (!isHasAlreadyDecoratedLanguageService(info)) {
+					const createPluginResult = createPluginCallback(ts, info);
+					const extensions = createPluginResult.languagePlugins
 						.map(plugin => plugin.typescript?.extraFileExtensions.map(ext => '.' + ext.extension) ?? [])
 						.flat();
+
+					// TODO: this logic does not seem to appear in the async variant
+					// (createAsyncLanguageServicePlugin)... bug?
 					projectExternalFileExtensions.set(info.project, extensions);
-					const getScriptSnapshot = info.languageServiceHost.getScriptSnapshot.bind(info.languageServiceHost);
-					const language = createLanguage<string>(
-						[
-							...languagePlugins,
-							{ getLanguageId: resolveFileLanguageId },
-						],
-						new FileMap(ts.sys.useCaseSensitiveFileNames),
-						(fileName, _, shouldRegister) => {
-							let snapshot: ts.IScriptSnapshot | undefined;
-							if (shouldRegister) {
-								// We need to trigger registration of the script file with the project, see #250
-								snapshot = getScriptSnapshot(fileName);
-							}
-							else {
-								snapshot = getScriptInfo(fileName)?.getSnapshot();
-								if (!snapshot) {
-									// trigger projectService.getOrCreateScriptInfoNotOpenedByClient
-									info.project.getScriptVersion(fileName);
-									snapshot = getScriptInfo(fileName)?.getSnapshot();
-								}
-							}
-							if (snapshot) {
-								language.scripts.set(fileName, snapshot);
-							}
-							else {
-								language.scripts.delete(fileName);
-							}
-						}
-					);
 
 					const { proxy, initialize } = createProxyLanguageService(info.languageService);
 					info.languageService = proxy;
-					initialize(language);
-					decorateLanguageServiceHost(ts, language, info.languageServiceHost);
-					setup?.(language);
+
+					createLanguageCommon(createPluginResult, ts, info, initialize);
 				}
 
 				return info.languageService;
-
-				function getScriptInfo(fileName: string) {
-					// getSnapshot could be crashed if the file is too large
-					try {
-						return info.project.getScriptInfo(fileName);
-					} catch { }
-				}
-			},
-			getExternalFiles(project, updateLevel = 0) {
-				if (
-					updateLevel >= (1 satisfies ts.ProgramUpdateLevel.RootNamesAndUpdate)
-					|| !externalFiles.has(project)
-				) {
-					const oldFiles = externalFiles.get(project);
-					const extensions = projectExternalFileExtensions.get(project);
-					const newFiles = extensions?.length ? searchExternalFiles(ts, project, extensions) : [];
-					externalFiles.set(project, newFiles);
-					if (oldFiles && !arrayItemsEqual(oldFiles, newFiles)) {
-						project.refreshDiagnostics();
-					}
-				}
-				return externalFiles.get(project)!;
 			},
+			getExternalFiles: makeGetExternalFiles(ts),
 		};
 		return pluginModule;
 	};
 }
-
-export function arrayItemsEqual(a: string[], b: string[]) {
-	if (a.length !== b.length) {
-		return false;
-	}
-	const set = new Set(a);
-	for (const file of b) {
-		if (!set.has(file)) {
-			return false;
-		}
-	}
-	return true;
-}
diff --git a/packages/typescript/lib/quickstart/languageServicePluginCommon.ts b/packages/typescript/lib/quickstart/languageServicePluginCommon.ts
new file mode 100644
index 00000000..0737c24f
--- /dev/null
+++ b/packages/typescript/lib/quickstart/languageServicePluginCommon.ts
@@ -0,0 +1,116 @@
+import { createLanguage, FileMap } from '@volar/language-core';
+import { Language, LanguagePlugin } from '@volar/language-core/lib/types';
+import type * as ts from 'typescript';
+import { resolveFileLanguageId } from '../common';
+import { decorateLanguageServiceHost, searchExternalFiles } from '../node/decorateLanguageServiceHost';
+
+export const externalFiles = new WeakMap<ts.server.Project, string[]>();
+export const projectExternalFileExtensions = new WeakMap<ts.server.Project, string[]>();
+export const decoratedLanguageServices = new WeakSet<ts.LanguageService>();
+export const decoratedLanguageServiceHosts = new WeakSet<ts.LanguageServiceHost>();
+
+/**
+ * Wrap `getScriptInfo` to handle large files that may crash the language service.
+ *
+ * Introduced to fix issues with converting `relatedInformation` (in Diagnostics)
+ * when working with large files.
+ *
+ * https://github.com/volarjs/volar.js/commit/e242709a91e9d2919dc4fa59278dd266fd11e7a3
+ */
+export function makeGetScriptInfoWithLargeFileFailsafe(info: ts.server.PluginCreateInfo) {
+	return (fileName: string) => {
+		// getSnapshot could be crashed if the file is too large
+		try {
+			return info.project.getScriptInfo(fileName);
+		} catch { }
+	};
+}
+
+export function createLanguageCommon(
+	createPluginResult: createPluginCallbackReturnValue,
+	ts: typeof import('typescript'),
+	info: ts.server.PluginCreateInfo,
+  initializeProxiedLanguageService: (language: Language<string>) => void) {
+	const getScriptSnapshot = info.languageServiceHost.getScriptSnapshot.bind(info.languageServiceHost);
+	const getScriptInfo = makeGetScriptInfoWithLargeFileFailsafe(info);
+
+	const language = createLanguage<string>(
+		[
+			...createPluginResult.languagePlugins,
+			{ getLanguageId: resolveFileLanguageId },
+		],
+		new FileMap(ts.sys.useCaseSensitiveFileNames),
+		(fileName, _, shouldRegister) => {
+			let snapshot: ts.IScriptSnapshot | undefined;
+			if (shouldRegister) {
+				// We need to trigger registration of the script file with the project, see #250
+				snapshot = getScriptSnapshot(fileName);
+			}
+			else {
+				snapshot = getScriptInfo(fileName)?.getSnapshot();
+				if (!snapshot) {
+					// trigger projectService.getOrCreateScriptInfoNotOpenedByClient
+					info.project.getScriptVersion(fileName);
+					snapshot = getScriptInfo(fileName)?.getSnapshot();
+				}
+			}
+			if (snapshot) {
+				language.scripts.set(fileName, snapshot);
+			}
+			else {
+				language.scripts.delete(fileName);
+			}
+		}
+	);
+
+	initializeProxiedLanguageService(language);
+	decorateLanguageServiceHost(ts, language, info.languageServiceHost);
+	createPluginResult.setup?.(language);
+}
+
+export const makeGetExternalFiles = (ts: typeof import('typescript')) => (project: ts.server.Project, updateLevel = 0) => {
+	if (updateLevel >= (1 satisfies ts.ProgramUpdateLevel.RootNamesAndUpdate)
+		|| !externalFiles.has(project)) {
+		const oldFiles = externalFiles.get(project);
+		const extensions = projectExternalFileExtensions.get(project);
+		const newFiles = extensions?.length ? searchExternalFiles(ts, project, extensions) : [];
+		externalFiles.set(project, newFiles);
+		if (oldFiles && !arrayItemsEqual(oldFiles, newFiles)) {
+			project.refreshDiagnostics();
+		}
+	}
+	return externalFiles.get(project)!;
+};
+
+export type createPluginCallbackReturnValue = {
+	languagePlugins: LanguagePlugin<string>[];
+	setup?: (language: Language<string>) => void;
+};
+
+export type createPluginCallbackSync = (ts: typeof import('typescript'), info: ts.server.PluginCreateInfo) => createPluginCallbackReturnValue;
+export type createPluginCallbackAsync = (ts: typeof import('typescript'), info: ts.server.PluginCreateInfo) => Promise<createPluginCallbackReturnValue>;
+
+function arrayItemsEqual(a: string[], b: string[]) {
+	if (a.length !== b.length) {
+		return false;
+	}
+	const set = new Set(a);
+	for (const file of b) {
+		if (!set.has(file)) {
+			return false;
+		}
+	}
+	return true;
+}
+
+export function isHasAlreadyDecoratedLanguageService(info: ts.server.PluginCreateInfo) {
+	if (decoratedLanguageServices.has(info.languageService)
+		|| decoratedLanguageServiceHosts.has(info.languageServiceHost)) {
+		return true;
+	} else {
+		decoratedLanguageServices.add(info.languageService);
+		decoratedLanguageServiceHosts.add(info.languageServiceHost);
+		return false;
+	}
+}
+

